import sys

n = int(sys.stdin.readline())
MAXN = 16
queens = [0 for x in range(n)]

def ischecked(x1, y1, x2, y2):
    # kaks lippu tulistavad üksteist, kui nad on samal real, veerul või diagonaalil
    return x1 == x2 or y1 == y2 or x2 - x1 == y2 - y1 or x2 - x1 == y1 - y2


def tryrow(y, n): # y = mitmendale reale proovime lippu panna
    res = 0
    for x in range(n): # proovime kõiki veerge
        underfire = False
        for y1 in range(y): # kontrollime kõiki eelnevaid lippe
            if ischecked(x, y, queens[y1], y1):
                underfire = True # ei sobi
                break
        if underfire:
            continue
        if y == n - 1:
            res += 1 # oleme viimasel real, liidame vastusele 1
        else:
            queens[y] = x # jätame uue lipu asukoha meelde
            res += tryrow(y + 1, n) # liidame järgmiste ridade võimalused
    return res

# alustame esimeselt realt, kust kutsutakse
# rekursiivselt välja järgmiste ridade proovimisi
res = tryrow(0, n)
print(res)